 NAM SANCTUM
*
* V1.2 - FIX SEVERAL PROBLEMS
*        DISCOVERED: (11/10/84)
*        . GET BOARDS/NAILS
*          WHILE STILL ON DOOR
*          RETURNED "I DON'T
*          SEE THEM"
*        . AFTER LAMP RAN OUT
*          OF LIGHT IT ALLOWED
*          PLAYER TO RE-LIGHT
*          IT AND CONTINUE ON
*        . THE WORD MOUNTAIN
*          WAS MISSPELLED IN
*          TWO PLACES
*        . THE DESCRIPTION
*          HANDCRAFTED ALTAR
*          WAS MISSPELLED
*
 ORG $0400
GSCRN EQU *
* VERB/NOUN COMPARE LENGTH
MAXWRD EQU 4
* MAX OBJECTS ALLOWED TO CARRY
MAXOBJ EQU 5
* MAX # PERMANENT OVERLAYS/RM
NOVLY  EQU 10
* MAX # MOVABLE OVERLAYS/OBJ
MVOBMX EQU 2
* MAX OBJECTS ALLOWED PER ROOM
RMOBJ  EQU 27
* SIZE OF ROOM TABLE ENTRY
RMSIZE EQU RMOBJ+6
* NUMBER OF ROOMS IN ADV
NORMS  EQU 24 NUMBER OF ROOMS
INV    EQU $80
BLACK  EQU 0
BLUE   EQU 1
RED    EQU 2
WHITE  EQU 3
MAXPNT EQU 1

* SWITCHES TO ENABLE/DISABLE
* UTILITY ROUTINES
*
* SET TO ZERO TO ENABLE RTN

R.SRIT EQU 0 SCROLL RIGHT
R.SLFT EQU 1 SCROLL LEFT
R.SUP  EQU 1 SCROLL UP
R.SDN  EQU 1 SCROLL DOWN
R.SFLP EQU 1 FLIP COLORS
R.RVIS EQU 1 MAKE ROOM VISIBLE
R.PNRM EQU 0 PUT 'N ROOM
R.XFOB EQU 1 XFER MOVABLE OBJ
R.FIND EQU 0 FIND OBJ IN GAME
R.XCHG EQU 0 CHG OBJ IN GAME

C.THE  EQU $80
C.SMAL EQU $81
C.ARE  EQU $82
C.SEE  EQU $83
C.CANT EQU $84
C.DONT EQU $85
C.LARG EQU $86
C.IM   EQU $87
C.INA  EQU $88
C.ONA  EQU $89
C.ISA  EQU $8A
C.IITS EQU $8B
C.TTHE EQU $8C
C.IS   EQU $8D
C.AND  EQU $8E
C.AN   EQU $8F
C.AT   EQU $90

* MACROS

DI MACR DISABLE IRQ
 ORCC #$50
 ENDM

EI MACR ENABLE IRQ
 ANDC #$EF
 ENDM

 ORG $0000
ROOM   RMB 1
RANDOM RMB 1
NEWRM  RMB 1
VERBNO RMB 1
NOUNNO RMB 1
VERB   RMB MAXWRD
NOUN   RMB MAXWRD
MSGLNS RMB 1
CLRSW  RMB 1
COLOR1 RMB 1
COLOR2 RMB 1
FLIPSW RMB 1
FLIPCT RMB 2
FLP2SW RMB 1
FLP2CT RMB 2
LITESW RMB 1
LITECT RMB 1
RMMOVE RMB 1
SCRTOP RMB 2
POINTS RMB 1
SCORE  RMB 2
OBJCNT RMB 1
OBJECT RMB MAXOBJ
*
* ADVENTURE UNIQUE VARIABLES
*
SNOWSW RMB 1 IF SNOW BLOCKS DOOR
SNO2SW RMB 1 IF SNOW IN JUG
NOTESW RMB 1 NOTE IN WOMAN HAND
NEEDSW RMB 1 IF GOT NEEDLES
FEATSW RMB 1 IF GOT FEATHER
VOICSW RMB 1 CNTL LISTEN VOICE
HAIRSW RMB 1 IF HAIR CUT
*
ENDVAR EQU *

*      JUMP VECTORS

CURPOS RMB 3
CLS    RMB 3
CHROUT RMB 3
DISPLY RMB 3
GETLIN RMB 3
BADINP RMB 3
REPLY  RMB 3
SCNKEY RMB 3
PERIOD RMB 3
CHGOBJ RMB 3
CKOBJ  RMB 3
MAKVIS RMB 3
GIVOBJ RMB 3
REPOBJ RMB 3
HAVOBJ RMB 3
GETOBJ RMB 3
PUTOBJ RMB 3
 IFEQ R.RVIS
RMVIS  RMB 3
 ENDC
CKDRAW RMB 3
DRAWSC RMB 3
LOCOBJ RMB 3

 REORG
 ORG $0E00

*      JMP VECTORS STORAGE

SJMPS EQU *
 JMP VEC01 CURPOS
 JMP VEC02 CLS
 JMP VEC03 CHROUT
 JMP VEC04 DISPLY
 JMP VEC05 GETLIN
 JMP VEC06 BADINP
 JMP VEC07 REPLY
 JMP VEC08 SCNKEY
 JMP VEC09 PERIOD
 JMP VEC10 CHGOBJ
 JMP VEC11 CKOBJ
 JMP VEC12 MAKVIS
 JMP VEC13 GIVOBJ
 JMP VEC14 REPOBJ
 JMP VEC15 HAVOBJ
 JMP VEC16 GETOBJ
 JMP VEC17 PUTOBJ
 IFEQ R.RVIS
 JMP VEC18 RMVIS
 ENDC
 JMP VEC19 CKDRAW
 JMP VEC20 DRAWSC
 JMP VEC21 LOCOBJ
EJMPS EQU *

 REORG

 RMB 6144 SCREEN MEMORY

START EQU *
 DI
 LDS #GSCRN

* BUILD THE ROOM SAVE TABLE
* IN HIGH MEMORY

 CLR ROOM
 LDB #NORMS
 LDX #ROOMTB
 LDY #$8000
A@ PSHS B
 INC ROOM
 LDB #RMOBJ
 LEAX 6,X
B@ LDA ROOM
 STA -1,Y
 LDA ,X+
 BEQ C@
 STA ,--Y
C@ DECB
 BNE B@
 PULS B
 DECB
 BNE A@
 CLR -1,Y

* COLD START INITIALIZATION

 LDA #1   INIT VARIABLES
 STA ROOM
 LDX #NEWRM
 LDB #ENDVAR-NEWRM
 CLRA
E@ STA ,X+
 DECB
 BNE E@
 LDY #SJMPS
 LDB #(EJMPS-SJMPS)/3
D@ LDA ,Y+
 STA ,X+
 LDU ,Y++
 STU ,X++
 DECB
 BNE D@
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP

* WARM START INITIALIZATION

WARM EQU *
 DI
 LDS #GSCRN
 STS SCRTOP
 LDX #FIRQ SETUP FIRQ VECTOR
 STX $010D
 STX $010A
 STX $0110
 LDA #$55 SETUP RESET VECTOR
 STA $0071
 LDX #RESET
 STX $0072
 CLR $FF40

* INITIALIZATION PARTICULAR
* TO CURRENT ADVENTURE

 LDA #100
 STA LITECT

* RESET INITIALIZATION

RESET NOP
 LDS #GSCRN
 STS SCRTOP
 LDA #$34
 STA $FF21
 STA $FF23
 STA $FF01
 INCA
 STA $FF03
 LDA $FF02
 LDA #$FF
 STA $FF22
 STA $FFC0
 STA $FFC3
 STA $FFC5
 LDD #GSCRN
 LSRA
 LDX #$FFC6
 LDB #7
C@ LSRA
 BCS A@
 STB ,X++
 BRA B@
A@ STB 1,X
 LEAX 2,X
B@ DECB
 BNE C@
 CLR NOUNNO
 LDX #GSCRN
 LDY #6144
 LDD #$5555
D@ STD ,X++
 LEAY -2,Y
 BNE D@
E@ JSR [$A000]
 BEQ E@
 LDX #BOMBIT
 STX $0072
 JSR CLS
 LDU #SCRN00
 JSR SHOSCR
 LDX #VERSN
 JSR DISPLY
 LDD #$0100
 STD ROWCOL
 LDX #MDPCRE
 JSR DISPLY
 LDD #$0D00
 STD ROWCOL
 LDX #CREDIT
 JSR DISPLY
G@ JSR [$A000]
 BEQ G@
 CLR SCORE
 EI
 JMP VLOOK

BOMBIT EQU *
 NOP
 DI
 LDX #NEWGAM
 STX $0072
A@ CLR ,X+
 CMPX #$8000
 BLO A@
B@ BRA B@

* WARM GAME RESET ROUTINE

NEWGAM EQU *
 LDB #NORMS
 CLRA
A@ INCA
 JSR CLRRM
 DECB
 BNE A@
 LDX #$8000
B@ LDA ,-X
 BEQ C@
 STA ROOM
 LDA ,-X
 JSR PUTNRM
 BRA B@
C@ CLR ROOM
 INC ROOM
 LDX #NEWRM
 LDB #ENDVAR-NEWRM
 CLRA
D@ STA ,X+
 DECB
 BNE D@
 JMP WARM

FIRQ EQU *
 JSR CHKANT
 INC RANDOM
 TST $FF00
 TST $FF02
 RTI


 INCL ADVENT00/ASM:1

 INCL ADVENT01/ASM:1

 INCL ADVENT02/ASM:1

 INCL ADVENT03/ASM:1

 INCL ADVENT04/ASM:1

 INCL SCREENS/ASM:1
 INCL OVERLAY1/ASM:1
 INCL OVERLAY2/ASM:1

VERSN FCC 'V1.2',0

MDPCRE EQU *
 FCB ' +$80,' +$80,' +$80
 FCC ' MAR','K+$80
 FCC 'DAT','A+$80
 FCC 'PRODUCTS',13,13
 FCB 6[$A0]
 FCC 'presents',0

CREDIT EQU *
 FCB 7[' +$80]
 FCC 'By',':+$80,13,13,' +$80
 FCC 'Stephe','n+$80
 FCC .O'De.,'a+$80
 FCB '&+$80
 FCC 'Bo','b+$80
 FCC 'Withers'
 FCB 13,13,13
 FCB ' +$80,' +$80,' +$80
 FCC ' Copyrigh','t+$80
 FCB $5C+$80 COPYRIGHT
 FCC '1981',13
 FCB 3[' +$80]
 FCC 'Mar','k+$80
 FCC 'Dat','a+$80
 FCC 'Products'
 FCB 13,3[$A0]
 FCC 'Al','l+$80
 FCC 'Right','s+$80
 FCC 'Reserved',0

 INCL ASCLNO/ASM:0

*******************************
*
* GENERAL PURPOSE STRING MOVE
*
*******************************

MOVE EQU *
 DI
 PSHS D,X,Y
A@ LDA ,X+
 STA ,Y+
 DECB
 BNE A@
 EI
 PULS D,X,Y,PC

*******************************
*
* DISPLAY COMPRESSED HI-RES
* SCREEN ON VIDEO
*
* INPUT:  U = PNTR TO SCREEN
* OUTPUT: NONE
*
*******************************

SHOSCR EQU *
 JSR CLS
SHOSC2 EQU *
 DI
 PSHS D,X,U
 LDX #GSCRN
A@ LDB ,U+
 BEQ C@
 CMPB #$FF
 BEQ E@
B@ LDA ,U+
 STA ,X+
 DECB
 BNE B@
 BRA A@
C@ LDB ,U+
 BEQ F@
 LDA ,U+
D@ STA ,X+
 DECB
 BNE D@
 BRA A@
 EI
E@ PULS D,X,U,PC
*
* PROCESS SPECIAL 6 BYTE
* REPEAT DESCRIPTOR
*
F@ LDB ,U+ LINE LEN
 STB REFRCT
 LDA ,U+ NUMBER OF LINES
 STA NLNSCT
 LDD ,U++ COLOR BYTES
 STD BYTE
G@ LDA BYTE
 LDB REFRCT
H@ STA ,X+
 DECB
 BNE H@
 LDD BYTE
 EXG A,B
 STD BYTE
 DEC NLNSCT
 BNE G@
 BRA A@

*******************************
*
* DISPLAY GRAPHIC OBJECT ON
* EXISTING SCREEN
* INPUT:  X = PNTR TO OBJECT
*
*******************************

SHOOBJ EQU *
 DI
 PSHS D,X,Y,U
 LDB #NOVLY NO OF OVERLAYS
 LDY #SCROBJ
A@ LDA ,X+
 BEQ B@
 PSHS B
 TFR A,B
 CLRA
 DECB
 LSLB
 ROLA
 LDU D,Y
 BSR SHOOVL
 PULS B
B@ DECB
 BNE A@
 LDA ROOM
 DECA
 LDB #RMSIZE
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 LDB #RMOBJ
C@ PSHS B
 LDA ,X+
 BEQ F@
 BMI F@
 LDY #MOVOBJ
D@ TST ,Y
 BEQ F@
 CMPA ,Y
 BEQ G@
E@ LEAY MVOBMX+2,Y
 BRA D@
F@ PULS B
 DECB
 BNE C@
 EI
 PULS D,X,Y,U,PC
G@ LDB 1,Y
 CMPB ROOM
 BNE E@
 PSHS A
 LEAY 2,Y
 LDA #MVOBMX
 PSHS A
H@ CLRA
 LDB ,Y+
 BEQ I@
 DECB
 LSLB
 ROLA
 LDU #SCROBJ
 LDU D,U
 BSR SHOOVL
I@ DEC 0,S
 BNE H@
 PULS A
 PULS A
 BRA F@

SHOOVL PSHS D,X,Y,U
 CLR MODE
D@ LDA ,U+
 DECA
 LDB #32
 MUL
 PSHS D
 LDB ,U+
 CLRA
 DECB
 LSRB
 LSRB
 ADDD ,S++
 ADDD #GSCRN-32
 STD H@
 LDB ,U+
 STB G@
E@ LDB G@
 LDX H@
 LEAX 32,X
 STX H@
F@ BSR OBJBYT
 STA ,X+
 DECB
 BNE F@
 BRA E@
G@ FCB 0 LINE LEN
H@ FDB 0 SCREEN PNTR

OBJBYT EQU *
 PSHS B,X,Y
 LDA MODE
 BEQ E@
 CMPA #3
 BEQ I@
 DECA
 BEQ D@
 LDB COUNT
A@ LDA ,U+
B@ DECB
 BNE C@
 CLR MODE
C@ STB COUNT
 PULS B,X,Y,PC
D@ LDB COUNT
 LDA BYTE
 BRA B@
E@ LDA ,U+
 BEQ F@
 CMPA #$FF
 BEQ G@
 TFR A,B
 LDA #2
 STA MODE
 BRA A@
F@ LDB ,U+
 BEQ H@ SPECIAL DESCRIPTOR
 LDA #1
 STA MODE
 LDA ,U+
 STA BYTE
 BRA B@
G@ PULS B,X,Y
 LEAS 2,S
 PULS D,X,Y,U,PC
*
* PROCESS SPECIAL DESCRIPTOR
*
H@ LDA #3
 STA MODE
 LDA ,U+ LINE LEN
 STA COUNT
 STA REFRCT
 LDA ,U+ # LINES
 STA NLNSCT
 LDD ,U++
 STD BYTE
I@ LDA BYTE
 LDB COUNT
 DECB
 BNE C@
 PSHS A
 LDD BYTE
 EXG A,B
 STD BYTE
 PULS A
 LDB REFRCT
 DEC NLNSCT
 BNE C@
 CLR MODE
 BRA C@

MODE FCB 0
BYTE FCB 0
BYTE2 FCB 0
NLNSCT FCB 0
REFRCT FCB 0
COUNT FCB 0

DELAY EQU *
 JSR DISPLY
 LDX #0
 LDB #5
A@ LEAX -1,X
 BNE A@
 DECB
 BNE A@
 RTS

*******************************
*
* CASSETTE SAVE GAME ROUTINE
*
*******************************

VSAVE EQU *
 LDD SCORE
 SUBD #1
 STD SCORE
 LDX #CASMSG
 JSR DISPLY
 JSR GETLIN
 JSR [$A00C] WRITE GAP
 CLR $7C WRITE HEADER BLK
 LDA #15
 STA $7D
 LDX #SAVHDR
 STX $7E
 JSR [$A008] WRITE BLK
 JSR [$A00C] WRITE GAP
 INC $7C
 LDA #CURPOS
 STA $7D
 LDX #ROOM
 STX $7E
 JSR [$A008] WRITE BLK
 LDA #255
 STA $7D
 LDB #(RMSIZE*NORMS)/255+2
 LDX #ROOMTB
 STX $7E
A@ PSHS B
 JSR [$A008] WRITE BLK
 LDX $7E
 LEAX 255,X
 STX $7E
 PULS B
 DECB
 BNE A@
 LDA #$FF
 STA $7C
 CLR $7D
 JSR [$A008] WRITE BLK
 LDA $FF21 TURN OFF CASSETTE
 ANDA #%11110111
 STA $FF21
 JMP REPLY

*******************************
*
* CASSETTE LOAD GAME ROUTINE
*
*******************************

VLOAD EQU *
 LDD SCORE
 SUBD #1
 STD SCORE
 LDX #CASMSG
 JSR DISPLY
 JSR GETLIN
 LDX #$02DD
 STX $7E
 JSR [$A004] READ GAP & BLK
 JSR [$A006]
 TST $81
 BNE D@ IF ERROR
 LDX #$02DD
 LDY #SAVHDR
 LDB #15
A@ LDA ,X+
 CMPA ,Y+
 BNE E@
 DECB
 BNE A@
 LDX #ROOM
 STX $7E
 JSR [$A004] READ GAP & BLK
 JSR [$A006]
 TST $81
 BNE D@ IF ERROR
 LDX #ROOMTB
B@ STX $7E
 JSR [$A006] READ BLK
 BNE D@ IF ERROR
 LDA $7C EOF?
 BMI C@ YES
 LDX $7E
 LEAX 255,X
 BRA B@
C@ LDA $FF21 TURN OFF CASSETTE
 ANDA #%11110111
 STA $FF21
 CLR NOUNNO
 JMP VLOOK
D@ LDX #IOERR
 BRA F@
E@ LDX #BADTAP
F@ JSR DISPLY
 JMP REPLY

CASMSG FCB 13
 FCC 'Read','y+$80
 FCC 'tap','e+$80
 FCB 'i,'n+$80
 FCC 'recorde','r+$80
 FCB C.AND
 FCC 'pres','s+$80
 FCC 'ENTER ',0

BADTAP FCB 13
 FCC 'Invali','d+$80
 FCC 'gam','e+$80
 FCC 'sav','e+$80
 FCC 'tape.',0

IOERR FCB 13
 FCC 'Tap','e+$80
 FCC 'I/','O+$80
 FCC 'error.',0

SAVHDR FCC 'SANCTUM '
 FCB 2,0,0
 FDB 0,0

*
* DYNAMIC SAVE ROOM TABLE
*
* FORMAT FCB ROOM#,OBJ#
*        FCB 0

 END START
Invali','d+$80
 FCC 'gam','e+$80
 FCC 'sav',