*  FILE: ADVENT03/ASM
*
* DATA VARIABLES AND TABLES
*

*******************************
*
* VERB TABLE.  EACH VERB IS
* LISTED FOLLOWED BY IT'S
* ASSIGNED VERB NUMBER.
*
*******************************

VERBTB EQU *
 FCC 'LOOK',1
 FCC 'L   ',1
 FCC 'EXAM',1
 FCC 'INVE',2
 FCC 'I   ',2
 FCC 'G   ',3
 FCC 'GET ',3
 FCC 'TAKE',3
 FCC 'GRAB',3
 FCC 'PUT ',4
 FCC 'DROP',4
 FCC 'P   ',4
 FCC 'THRO',4
 FCC 'NORT',5
 FCC 'N   ',5
 FCC 'SOUT',6
 FCC 'S   ',6
 FCC 'EAST',7
 FCC 'E   ',7
 FCC 'WEST',8
 FCC 'W   ',8
 FCC 'UP  ',9
 FCC 'U   ',9
 FCC 'DOWN',10
 FCC 'D   ',10
 FCC 'GO  ',11
 FCC 'WALK',11
 FCC 'RUN ',11
 FCC 'SAVE',13
 FCC 'LOAD',14
 FCC 'HELP',15
 FCC 'SCOR',16
 FCC 'QUIT',17
 FCC 'OPEN',18
 FCC 'CLIM',19
 FCC 'READ',20
 FCC 'PLAY',21
 FCC 'CLOS',22
 FCC 'UNLO',23
 FCC 'BREA',24
 FCC 'SMAS',24
 FCC 'BUIL',25
 FCC 'MAKE',25
 FCC 'PULL',26
 FCC 'HEAR',27
 FCC 'LIST',27
 FCC 'CUT ',28
 FCC 'CLIP',28
 FCC 'SAW ',28
 FCC 'LIGH',29
 FCC 'UNLI',30
 FCC 'EXTI',30
 FCC 'SNUF',30
 FCC 'WEAR',31
 FCC 'ENTE',32
 FCC 'GIVE',33
 FCC 'TAST',34
 FCC 'DRIN',35
 FCC 'DIG ',36
 FCC 'SHOV',36
 FCC 'INVO',37
 FCB 0

*******************************
*
* NOUN TABLE.  LISTS ALL NOUNS
* AND THEIR ASSOCIATED NUMBER
*
*******************************

NOUNTB EQU *
 FCC 'NORT',1
 FCC 'SOUT',2
 FCC 'EAST',3
 FCC 'WEST',4
 FCC 'UP  ',5
 FCC 'DOWN',6
 FCC 'INVE',7
 FCC 'SNOW',9
 FCC 'NEED',10
 FCC 'JUG ',11
 FCC 'WINE',11
 FCC 'NET ',15
 FCC 'MATC',16
 FCC 'WOMA',17
 FCC 'GIRL',17
 FCC 'HOOD',18
 FCC 'ROBE',18
 FCC 'MANU',19
 FCC 'PARC',20
 FCC 'MUSI',20
 FCC 'LANT',21
 FCC 'LAMP',21
 FCC 'KEY ',23
 FCC 'KEYS',23
 FCC 'SHEA',24
 FCC 'SAW ',25
 FCC 'RAVE',26
 FCC 'HAMM',27
 FCC 'BOAR',28
 FCC 'NAIL',29
 FCC 'HAIR',30
 FCC 'SHEE',31
 FCC 'SALT',32
 FCC 'SHOV',33
 FCC 'FEAT',34
 FCC 'MESS',35
 FCC 'NOTE',35
 FCC 'EMBL',36
 FCC 'SLEE',36
 FCC 'BACH',37
 FCC 'FUGU',37
 FCC 'ASH ',38
 FCC 'ASHE',38
 FCC 'EPIS',39
 FCC 'PASS',100
 FCC 'PINE',101
 FCC 'TREE',101
 FCC 'SKEL',104
 FCC 'PLAQ',105
 FCC 'BRON',105
 FCC 'BOOK',106
 FCC 'ALTA',107
 FCC 'ALTE',107
 FCC 'MANT',108
 FCC 'CABI',110
 FCC 'COFF',112
 FCC 'VENT',114
 FCC 'OPEN',114
 FCC 'MAN ',115
 FCC 'CARE',115
 FCC 'LECT',116
 FCC 'CIRC',117
 FCC 'STAT',118
 FCC 'ORGA',120
 FCC 'MIRR',121
 FCC 'CLOS',122
 FCC 'BED ',123
 FCC 'STAI',124
 FCC 'STEP',124
 FCC 'FIRE',125
 FCC 'DOOR',127
 FCC 'ALL ',128
 FCC 'EVER',128
 FCB 0

*******************************
*
* SPECIAL ACTION TABLE. LISTS
* VERB/NOUN COMBO'S THAT HAVE
* SPECIAL PROCESSING ROUTINES.
* FORMAT IS:
*
*  # BYTES       DEXCRIPTION
*  -------   ------------------
*     1      VERB NUMBER
*     1      NOUN NUMBER
*     2      SPECIAL RTN ADDR
*
*******************************

SPCRTN EQU *
 FDB $016E,LOOK01 LOOK CABIN
 FDB $0109,LOOK02 LOOK SNOW
 FDB $016C,LOOK03 LOOK MANTLE
 FDB $0172,LOOK04 LOOK VENT
 FDB $016A,LOOK05 LOOK BOOKS
 FDB $017F,LOOK06 LOOK DOOR
 FDB $0124,LOOK07 LOOK EMBLEM
 FDB $011E,LOOK08 LOOK HAIR
 FDB $0111,LOOK09 LOOK WOMAN
 FDB $010A,LOOK11 LOOK NEEDLES
 FDB $0123,LOOK12 LOOK NOTE
 FDB $0168,LOOK13 LOOK SKELETON
 FDB $0120,LOOK14 LOOK SALT
 FDB $011C,LOOK15 LOOK BOARDS
 FDB $011D,LOOK15 LOOK NAILS
 FDB $0307,VINVE TAKE INVENTORY
 FDB $0320,GET01 GET SALT
 FDB $0323,GET02 GET NOTE
 FDB $0309,GET03 GET SNOW
 FDB $030A,GET04 GET NEEDLES
 FDB $0317,GET05 GET KEYS
 FDB $0318,GET05 GET SHEARS
 FDB $0319,GET05 GET SAW
 FDB $0322,GET07 GET FEATHER
 FDB $031A,GET08 GET RAVEN
 FDB $0368,GET09 GET SKELETON
 FDB $031F,GET10 GET SHEET
 FDB $031E,GET11 GET HAIR
 FDB $036C,GET12 GET MANTLE
 FDB $0409,PUT01 PUT SNOW
 FDB $0426,PUT02 PUT ASH
 FDB $0B6E,GO01  GO CABIN
 FDB $0B7F,GO02  GO DOOR
 FDB $0B7A,GO03  GO CLOSET
 FDB $0B79,GO04  GO MIRROR
 FDB $0B7C,GO05  GO STEPS
 FDB $0B72,GO06  GO VENT
 FDB $0B64,GO07  GO PASSAGE
 FDB $127F,OPEN01 OPEN DOOR
 FDB $1270,OPEN02 OPEN COFFIN
 FDB $137C,GO05  CLIMB STEPS
 FDB $1413,LOOKOB READ MANU
 FDB $1423,LOOK12 READ NOTE
 FDB $1469,LOOKOB READ PLAQUE
 FDB $1414,LOOKOB READ MUSIC
 FDB $1525,PLAY01 PLAY BACH
 FDB $1514,PLAY02 PLAY MUSIC
 FDB $167F,CLOS01 CLOSE DOOR
 FDB $1A22,GET07  PULL FEATHER
 FDB $1F12,VGET   WEAR ROBE
 FDB $2079,GO04   ENTER MIRROR
 FDB $207A,GO03   ENTER CLOSET
 FDB $206E,GO01   ENTER CABIN
 FDB $2064,GO07   ENTER PASSAGE
 FDB $2072,GO06   ENTER VENT
 FDB $207F,GO02   ENTER DOOR
 FDB $210B,VPUT   GIVE WINE
 FDB $230B,VTASTE DRINK WINE
 FDB 0

*******************************
*
* SPECIAL ACTION ON ENTRY TO A
* ROOM TABLE.  FORMAT IS:
*      ROOM#,RTNADDR
*
*******************************

ENTRTB EQU *
 FCB 5,>ENTR05
 FCB 12,>ENTR12
 FCB 13,>ENTR12
 FCB 0

*******************************
*
* SPECIAL ACTION ON EXIT FROM
* A ROOM TABLE.
*
*******************************

EXITTB EQU *
 FCB 11,>EXIT11
 FCB 12,>EXIT12
 FCB 13,>EXIT12
 FCB 0

*******************************
*
* SPECIAL ACTION FOR COMMANDS
* GIVEN WHILE IN A ROOM TABLE
*
*******************************

INRMTB EQU *
 FCB 5,>INRM05
 FCB 13,>INRM13
 FCB 18,>INRM18
 FCB 0

* ROOM TO SHOW HOODED FIGURE

FIGRMS EQU *
 FCB 8,9,14,15,16,17,19,21,22
 FCB 0

*******************************
*
* MESSAGE TABLE FOR GENERAL
* LOOK AT OBJECT ROUTINE
*
* FMT: FCB OBJ#
*          MSG# IF CARRYING
*          MSG# IF IN ROOM
*
*******************************

OBJMSG EQU *
 FCB 121,0,38   MIRROR
 FCB 125,0,39   FIREPLACE
 FCB 118,0,42   STATUES
 FCB 116,0,43   LECTERN
 FCB 19,45,10   MANUSCRIPT
 FCB 18,46,46   ROBE
 FCB 105,0,47   PLAQUE
 FCB 123,0,51   BED
 FCB 35,52,10   MESSAGE
 FCB 20,59,10   MUSIC
 FCB 98,0,68    STATUE OF WOMAN
 FCB 11,53,53   JUG/WINE
 FCB 12,22,22   JUG/EMPTY
 FCB 13,54,54   JUG/SNOW
 FCB 14,55,55   JUG/WATER
 FCB 112,0,29   CLOSED COFFIN
 FCB 111,0,81   OPEN COFFIN
 FCB 21,32,32   UNLIT LAMP
 FCB 22,31,31   LIT LAMP
 FCB 117,0,90   CIRCLE OF SALT
 FCB 113,0,93   STONE STEPS
 FCB 120,0,94   ORGAN
 FCB 119,0,94   ORGAN
 FCB 0

*******************************
* OBJECT EQUATE TABLE DEFINES
* OBJECTS THAT MAY HAVE MULTIPLE
* OBJECT NUMBERS.
*
* FORMAT: FCB X,Y,Y,Y,Y
*  WHERE: X = PRIMARY OBJ #
*         Y = SECONDARY OBJ #
*             OR ZERO FOR NONE
*******************************

EQUTAB EQU *
 FCB 112,111,0,0,0     COFFIN
 FCB 127,126,103,102,122 DOOR
 FCB 120,119,0,0,0     ORGAN
 FCB 118,98,0,0,0      STATUES
 FCB 115,99,0,0,0      OLD MAN
 FCB 110,109,0,0,0     CABIN
 FCB 11,12,13,14,0     JUG
 FCB 21,22,0,0,0       LAMP
 FCB 124,113,0,0,0     STEPS
 FCB 28,103,0,0,0      BOARDS
 FCB 29,103,0,0,0      NAILS
 FCB 0

*******************************
* DEFINE OBJECTS THAT SHOULD
* BE REFERRED TO AS "THEM"
*
* FORMAT IS: OBJ#,TYPE
*      WHERE TYPE IS:
*            0 = IT
*            1 = THEM
*            2 = HER
*            3 = HIM
*
*******************************

THEMTB EQU *
 FCB 124,1  STAIRS
 FCB 118,1  STATUES
 FCB 115,3  OLD MAN
 FCB 10,1   PINE NEEDLES
 FCB 16,1   MATCHES
 FCB 23,1   KEYS
 FCB 24,1   SHEARS
 FCB 28,1   BOARDS
 FCB 29,1   NAILS
 FCB 17,2   WOMAN
 FCB 0

*******************************
* LITERAL TABLE FOR IT,THEM,HIM
* HER MESSAGES.
*******************************

LITTAB EQU *
 FCC 'it.',0
 FCC 'them.',0
 FCC 'her.',0
 FCC 'him.',0

*******************************
*
* ROOM TABLE.  DEFINES THE
* LAYOUT OF THE ADVENTURE. EACH
* ENTRY HAS THE FOLLOWING
* FORMAT:
*
* # BYTES        DESCRIPTION
* -------   -------------------
*    1      ROOM # TO NORTH
*    1      ROOM # TO SOUTH
*    1      ROOM # TO EAST
*    1      ROOM # TO WEST
*    1      ROOM # UP
*    1      ROOM # DOWN
*   RMOBJ   OBJECTS IN ROOM
*
*******************************

ROOMTB EQU *
*ROOM 1
 FCB 2,2,0,2,0,0
 FCB 101,109
 FCB RMOBJ-2[0]
*ROOM 2
 FCB 2,3,2,2,0,0
 FCB 101
 FCB RMOBJ-1[0]
*ROOM 3
 FCB 2,2,1,2,0,0
 FCB 101
 FCB RMOBJ-1[0]
*ROOM 4
 FCB 0,0,0,1,0,0
 FCB 33,126
 FCB RMOBJ-2[0]
*ROOM 5
 FCB 0,0,0,0,0,0
 FCB 127,124,125,11,16+INV,15
 FCB RMOBJ-6[0]
*ROOM 6
 FCB 0,0,0,0,0,5
 FCB 122,123,124,17,31+INV
 FCB RMOBJ-5[0]
*ROOM 7
 FCB 0,0,0,6,0,0
 FCB 121,18
 FCB RMOBJ-2[0]
*ROOM 8
 FCB 0,9,0,0,0,0
 FCB 121
 FCB RMOBJ-1[0]
*ROOM 9
 FCB 8,0,19,14,0,0
 FCB 126,105
 FCB RMOBJ-2[0]
*ROOM 10
 FCB 9,0,0,0,0,0
 FCB 120,118
 FCB RMOBJ-2[0]
*ROOM 11
 FCB 0,0,0,0,0,0
 FCB 117,26,116,100
 FCB RMOBJ-4[0]
*ROOM 12
 FCB 13,0,0,0,0,0
 FCB 113,114
 FCB RMOBJ-2[0]
*ROOM 13
 FCB 0,12,0,0,0,0
 FCB 112,27
 FCB RMOBJ-2[0]
*ROOM 14
 FCB 15,21,9,0,0,0
 FCB RMOBJ-0[0]
*ROOM 15
 FCB 0,14,0,16,0,0
 FCB RMOBJ-0[0]
*ROOM 16
 FCB 19,17,15,0,0,0
 FCB RMOBJ-0[0]
*ROOM 17
 FCB 16,0,0,0,0,0
 FCB 124
 FCB RMOBJ-1[0]
*ROOM 18
 FCB 0,0,0,0,0,17
 FCB 115,124,23,24,25
 FCB RMOBJ-5[0]
*ROOM 19
 FCB 20,16,0,9,0,0
 FCB RMOBJ-0[0]
*ROOM 20
 FCB 0,19,21,0,0,0
 FCB 106,19+INV,20+INV
 FCB RMOBJ-3[0]
*ROOM 21
 FCB 14,22,0,20,0,0
 FCB RMOBJ-0[0]
*ROOM 22
 FCB 21,0,23,0,0,0
 FCB RMOBJ-0[0]
*ROOM 23
 FCB 0,0,0,22,0,0
 FCB 103,21
 FCB RMOBJ-2[0]
*ROOM 24
 FCB 0,0,0,0,0,0
 FCB RMOBJ-0[0]

*******************************
* TREASURE POINT TABLE
*
* FORMAT: FCB TREASURE,POINTS
*******************************

PNTTAB EQU *
 FCB 0

*******************************
*
* GRAPHIC SCREEN INDICATOR
* TABLE (BY ROOM)
*
*******************************

SCRIND EQU *
*ROOM 1
 FCB 6,1,2,NOVLY-2[0]
*ROOM 2
 FCB 6,3,NOVLY-1[0]
*ROOM 3
 FCB 6,3,NOVLY-1[0]
*ROOM 4
 FCB 5,5,NOVLY-1[0]
*ROOM 5
 FCB 1,59,18,19,20,21,12,13,16,17,15,NOVLY-10[0]
*ROOM 6
 FCB 4,59,27,26,28,29,30,58,NOVLY-7[0]
*ROOM 7
 FCB 7,34,38,41,42,32,33,39,35,36,37,NOVLY-10[0]
*ROOM 8
 FCB 8,43,44,45,8,9,10,11,NOVLY-7[0]
*ROOM 9
 FCB 8,46,48,8,9,10,11,NOVLY-6[0]
*ROOM 10
 FCB 1,110,111,114,115,117,118
 FCB 119,120,112,113,NOVLY-10[0]
*ROOM 11
 FCB 2,109,105,106,107,108,98
 FCB 101,102,103,NOVLY-9[0]
*ROOM 12
 FCB 9,51,52,46,60,61,62,63,64,NOVLY-8[0]
*ROOM 13
 FCB 9,51,52,47,94,95,NOVLY-5[0]
*ROOM 14
 FCB 8,46,47,8,9,10,11,NOVLY-6[0]
*ROOM 15
 FCB 9,46,51,52,53,56,8,11,NOVLY-7[0]
*ROOM 16
 FCB 8,46,47,8,9,10,11,NOVLY-6[0]
*ROOM 17
 FCB 9,47,54,51,52,53,56,8,11,NOVLY-8[0]
*ROOM 18
 FCB 4,72,84,85,90,92,NOVLY-5[0]
*ROOM 19
 FCB 8,47,8,9,10,11,NOVLY-5[0]
*ROOM 20
 FCB 1,72,75,68,69,70,71,NOVLY-6[0]
*ROOM 21
 FCB 8,46,8,9,10,11,NOVLY-5[0]
*ROOM 22
 FCB 9,51,52,53,56,46,8,11,NOVLY-7[0]
*ROOM 23
 FCB 1,72,75,80,71,NOVLY-4[0]
*ROOM 24
 FCB 2,109,105,106,107,108,137,138,NOVLY-7[0]

*******************************
*
* ANTIMATION ROUTINES BY ROOM
*
* FORMAT: ROOM #,RTN VECTOR
*
*******************************

ANTTAB EQU *
 FCB 1,>MOVSMO
 FCB 2,>MOVCLO
 FCB 3,>MOVCLO
 FCB 5,>MOVFIR
 FCB 8,>MOVTR4
 FCB 9,>MOVTR4
 FCB 11,>MOVEYE
 FCB 14,>MOVTR4
 FCB 15,>MOVTR2
 FCB 16,>MOVTR4
 FCB 17,>MOVTR2
 FCB 19,>MOVTR4
 FCB 21,>MOVTR4
 FCB 22,>MOVTR2
 FCB 0

*******************************
*
* IF OBJECT DROPPED IN ROOM
* PUT IT IN ANOTHER ROOM TABLE
*
* FORMAT: CURR ROOM,NEW ROOM
*
*******************************

PUTTAB EQU *
 FCB 0

*******************************
*
* MOVABLE OBJ TABLE
*
* OBJECT #,ROOM #,OVERLAY #
*
*******************************

MOVOBJ EQU *
* SHOVEL
 FCB 33,1,125,126
 FCB 33,2,125,126
 FCB 33,3,125,126
 FCB 33,4,6,0
 FCB 33,5,125,126
 FCB 33,6,125,126
 FCB 33,8,125,126
 FCB 33,9,125,126
 FCB 33,12,125,126
 FCB 33,14,125,126
 FCB 33,16,125,126
 FCB 33,17,125,126
 FCB 33,18,125,126
 FCB 33,19,125,126
 FCB 33,20,125,126
 FCB 33,21,125,126
 FCB 33,22,125,126
 FCB 33,23,125,126
* DOOR
 FCB 127,4,7,0
 FCB 126,4,4,0
 FCB 127,5,22,57
 FCB 126,5,23,0
 FCB 127,9,50,55
 FCB 126,9,49,0
 FCB 103,23,76,81
 FCB 102,23,82,83
 FCB 113,12,65,0
 FCB 96,12,66,67
* MATCHES
 FCB 16,5,24,0
* SNOW
 FCB 97,5,25,0
* WOMAN
 FCB 17,6,31,0
* ROBE
 FCB 18,7,40,0
* MANUSCRIPT
 FCB 19,20,73,0
* PARCHMENT (MUSIC)
 FCB 20,20,74,0
* LANTERN
 FCB 21,23,77,0
 FCB 22,23,77,0
* SHEARS
 FCB 24,1,86,0
 FCB 24,2,86,0
 FCB 24,3,86,0
 FCB 24,5,86,0
 FCB 24,6,86,0
 FCB 24,8,86,0
 FCB 24,9,86,0
 FCB 24,12,86,0
 FCB 24,14,86,0
 FCB 24,16,86,0
 FCB 24,17,86,0
 FCB 24,18,86,0
 FCB 24,19,86,0
 FCB 24,21,86,0
 FCB 24,22,86,0
 FCB 24,23,86,0
* KEYS
 FCB 23,1,87,124
 FCB 23,2,87,124
 FCB 23,3,87,124
 FCB 23,5,87,124
 FCB 23,6,87,124
 FCB 23,7,87,124
 FCB 23,8,87,124
 FCB 23,9,87,124
 FCB 23,12,87,124
 FCB 23,14,87,124
 FCB 23,15,87,124
 FCB 23,16,87,124
 FCB 23,17,87,124
 FCB 23,18,87,124
 FCB 23,19,87,124
 FCB 23,20,87,124
 FCB 23,21,87,124
 FCB 23,22,87,124
 FCB 23,23,87,124
* HAND SAW
 FCB 25,1,88,89
 FCB 25,2,88,89
 FCB 25,3,88,89
 FCB 25,5,88,89
 FCB 25,6,88,89
 FCB 25,7,88,89
 FCB 25,8,88,89
 FCB 25,9,88,89
 FCB 25,12,88,89
 FCB 25,14,88,89
 FCB 25,15,88,89
 FCB 25,16,88,89
 FCB 25,17,88,89
 FCB 25,18,88,89
 FCB 25,19,88,89
 FCB 25,20,88,89
 FCB 25,21,88,89
 FCB 25,22,88,89
 FCB 25,23,88,89
* COFFIN
 FCB 112,13,93,0
 FCB 111,13,96,97
* BOARDS ON FLOOR
 FCB 28,5,78,79
 FCB 28,20,78,79
 FCB 28,23,78,79
* RAVEN
 FCB 26,11,99,100
* HOODED FIGURE
 FCB 95,11,104,0
* ORGAN
 FCB 120,10,116,0
 FCB 119,10,122,121
* OLD MAN
 FCB 115,18,91,0
 FCB 99,15,123,0
* BUTTERFLY NET
 FCB 15,1,127,128
 FCB 15,2,127,128
 FCB 15,3,127,128
 FCB 15,5,127,128
 FCB 15,6,127,128
 FCB 15,8,127,128
 FCB 15,12,127,128
 FCB 15,13,127,128
 FCB 15,14,127,128
 FCB 15,15,127,128
 FCB 15,16,127,128
 FCB 15,17,127,128
 FCB 15,18,127,128
 FCB 15,19,127,128
 FCB 15,20,127,128
 FCB 15,21,127,128
 FCB 15,22,127,128
 FCB 15,23,127,128
* JUG OF WINE
 FCB 11,5,129,0
 FCB 12,5,129,0
 FCB 14,5,129,0
 FCB 11,15,129,0
 FCB 12,15,129,0
 FCB 14,15,129,0
 FCB 11,18,129,0
 FCB 12,18,129,0
 FCB 14,18,129,0
 FCB 11,20,129,0
 FCB 12,20,129,0
 FCB 14,20,129,0
 FCB 11,23,129,0
 FCB 12,23,129,0
 FCB 14,23,129,0
* ALTAR
 FCB 107,13,130,0
* HAMMER
 FCB 27,8,131,0
 FCB 27,9,131,0
 FCB 27,12,131,0
 FCB 27,13,131,0
 FCB 27,14,131,0
 FCB 27,15,131,0
 FCB 27,16,131,0
 FCB 27,17,131,0
 FCB 27,19,131,0
 FCB 27,21,131,0
 FCB 27,22,131,0
* STATUES IN IMPRESSIVE ROOM
 FCB 118,10,132,133
* FLAMING SALT
 FCB 94,11,134,135
* STATUE OF ME
 FCB 118,11,137,138
* STATUE OF WOMAN
 FCB 98,11,139,140
* FEATHER
 FCB 34,11,136,0
 FCB 0

*******************************
*
* GRAPHIC SCREEN PNTR TABLE
*
*******************************

SCRTAB EQU *
 FDB SCRBLU,SCRBLK,SCRWHT
 FDB SCRRED,SCRCAB,SCRWDS
 FDB SCRCLO,SCRCOR,SCRCR1

*******************************
*
* GRAPHIC OBJECT PNTR TABLE
*
* FORMAT: SCREEN ROW  - XX
*         SCREEN COL  - XX
*         LINE LEN    - XX
*         DATA        - XX..XX
*         TERM BY $FF
*
*******************************

SCROBJ EQU *
 FDB OVCBN1,OVCBN2,OVTRE1
 FDB OVDOR1,OVSNO1,OVSVL1
 FDB OVDOR2,OVTR12,OVTR22
 FDB OVTR32,OVTR42,OVFIR1
 FDB OVFIR2,OVFIR3,OVFIR4
 FDB OVSTA1,OVSTA2,OVWAL1
 FDB OVWAL2,OVWAL3,OVWAL4
 FDB OVDOR3,OVDOR4,OVMAT1
 FDB OVSNO2,OVBED1,OVBED2
 FDB OVBED3,OVBED4,OVBED5
 FDB OVBED6,OVCLS1,OVCLS2
 FDB OVCLS3,OVCLS4,OVCLS5
 FDB OVCLS6,OVCLS7,OVCLS8
 FDB OVCLS9,OVCLSA,OVCLSB
 FDB OVCOR1,OVCOR2,OVCOR3
 FDB OVCOR4,OVCOR5,OVCOR6
 FDB OVCOR7,OVCOR8,OVCOR9
 FDB OVCORA,OVTOR1,OVCORC
 FDB OVCORB,OVTOR4,OVDOR5
 FDB OVBED7,OVFLR2,OVPAS1
 FDB OVPAS2,OVPAS3,OVPAS4
 FDB OVPAS5,OVPAS6,OVPAS7
 FDB OVPAS8,OVSTD1,OVSTD2
 FDB OVSTD3,OVSTD4,OVFLR1
 FDB OVSTD5,OVSTD6,OVALC1
 FDB OVALC2,OVALC3,OVALC4
 FDB OVALC5,OVALC6,OVALC7
 FDB OVALC8,OVALC9,OVLFT1
 FDB OVLFT2,OVLFT3,OVLFT4
 FDB OVLFT5,OVLFT6,OVLFT7
 FDB OVLFT8,OVLFT9,OVCRY1
 FDB OVCRY2,OVCRY3,OVCRY4
 FDB OVCRY5,OVSTR1,OVSTR2
 FDB OVSTR3,OVSTR4,OVSTR5
 FDB OVSTR6,OVSTR7,OVSTR8
 FDB OVSTR9,OVSTRA,OVSTRB
 FDB OVSTRC,OVIMP1,OVIMP2
 FDB OVIMP3,OVIMP4,OVIMP5
 FDB OVIMP6,OVIMP7,OVIMP8
 FDB OVIMP9,OVIMPA,OVIMPB
 FDB OVIMPC,OVIMPD,OVMAN1
 FDB OVLFTA,OVSVL2,OVSVL3
 FDB OVNET1,OVNET2,OVJUG1
 FDB OVATR1,OVHAM1,OVSTX1
 FDB OVSTX2,OVSTRD,OVSTRE
 FDB OVSTRF,OVSTX3,OVSTX4
 FDB OVSTX5,OVSTX6

GENHLP EQU *
 FCB 13,'T,'r,'y+$80
 FCC 'examinin','g+$80
 FCC 'things.',0

 FCB 13,'N,'o+$80
 FCC 'HEL','P+$80
 FCC 'available.',0

 FCB 13,'U,'s,'e+$80
 FCC 'SAV','E+$80
 FCC 'whe','n+$80
 FCC 'enterin','g+$80
 FCC 'dangerou','s+$80
 FCC 'areas.',0

 FCB 13,'I,'','m+$80
 FCC 'stumpe','d+$80
 FCC 'too!',0

*******************************
*
* DIRECTION DESCRIPTIONS TABLE
*
*******************************

DIRECT EQU *
 FCC 'North',',+$80,0
 FCC 'South',',+$80,0
 FCC 'East',',+$80,0
 FCC 'West',',+$80,0
 FCC 'Up',',+$80,0
 FCC 'Down',',+$80,0

*******************************
*
* OBJECT DESCRIPTIONS TABLE
*
*******************************

OBJTAB EQU *

 FCB 9
 FCC 'snow',0

 FCB 10
 FCC 'pin','e+$80
 FCC 'needles',0

 FCB 11,'a+$80
 FCC 'ju','g+$80,'o,'f+$80
 FCC 'wine',0

 FCB 12,C.AN
 FCC 'empt','y+$80
 FCC 'jug',0

 FCB 13,'a+$80
 FCC 'ju','g+$80
 FCC 'ful','l+$80,'o,'f+$80
 FCC 'snow',0

 FCB 14,'a+$80
 FCC 'ju','g+$80
 FCC 'ful','l+$80,'o,'f+$80
 FCC 'water',0

 FCB 15,'a+$80
 FCC 'butterfl','y+$80
 FCC 'net',0

 FCB 16
 FCC 'matches',0

 FCB 17,'a+$80
 FCC 'youn','g+$80
 FCC 'woman',0

 FCB 18,'a+$80
 FCC 'hoode','d+$80
 FCC 'robe',0

 FCB 19,C.AN
 FCC 'ol','d+$80
 FCC 'manuscript',0

 FCB 20,'a+$80
 FCC 'parchmen','t+$80
 FCC 'wit','h+$80
 FCC 'musica','l+$80
 FCC 'scoring',0

 FCB 21,C.AN
 FCC 'unli','t+$80
 FCC 'lantern',0

 FCB 22,'a+$80
 FCC 'lighte','d+$80
 FCC 'lantern',0

 FCB 23,'a+$80
 FCC 'rin','g+$80,'o,'f+$80
 FCC 'keys',0

 FCB 24
 FCC 'garde','n+$80
 FCC 'shears',0

 FCB 25,'a+$80
 FCC 'han','d+$80
 FCC 'saw',0

 FCB 26,'a+$80,C.LARG
 FCC 'blac','k+$80
 FCC 'raven',0

 FCB 27,'a+$80
 FCC 'cla','w+$80
 FCC 'hammer',0

 FCB 28
 FCC 'woode','n+$80
 FCC 'boards',0

 FCB 29
 FCC 'nails',0

 FCB 30,'a+$80
 FCC 'loc','k+$80,'o,'f+$80
 FCC 'hair',0

 FCB 31,'a+$80
 FCC 'whit','e+$80
 FCC 'sheet',0

 FCB 32
 FCC 'salt',0

 FCB 33,'a+$80
 FCC 'shovel',0

 FCB 34,'a+$80
 FCC 'blac','k+$80
 FCC 'feather',0

 FCB 35,'a+$80
 FCC 'handwritte','n+$80
 FCC 'message',0

 FCB 38
 FCC 'ashes',0

 FCB 95
 FCC 'hoode','d+$80
 FCC 'figures',0

 FCB 96,$FF,113,0

 FCB 97,$FF,9,0

 FCB 98,'a+$80
 FCC 'statu','e+$80
 FCB 'o,'f+$80,'a+$80
 FCC 'youn','g+$80
 FCC 'woman',0

 FCB 99,'a+$80
 FCC 'sleepin','g+$80
 FCC 'ol','d+$80
 FCC 'man',0

 FCB 100,'a+$80
 FCC 'secre','t+$80
 FCC 'passage',0

 FCB 101
 FCC 'pin','e+$80
 FCC 'trees',0

 FCB 102,'a+$80
 FCC 'doorway',0

 FCB 103,'a+$80
 FCC 'boarde','d+$80,'u,'p+$80
 FCC 'doorway',0

 FCB 104,'a+$80
 FCC 'skeleton',0

 FCB 105,'a+$80
 FCC 'bronz','e+$80
 FCC 'plaque',0

 FCB 106
 FCC 'bookcases',0

 FCB 107,'a+$80
 FCC 'handcrafte','d+$80
 FCC 'altar',0

 FCB 109,'a+$80
 FCC 'cabi','n+$80
 FCB 'i,'n+$80,C.THE
 FCC 'distance',0

 FCB 110,'a+$80
 FCC 'cabin',0

 FCB 111,C.AN
 FCC 'ope','n+$80
 FCC 'coffin',0

 FCB 112,'a+$80
 FCC 'coffin',0

 FCB 113,C.LARG
 FCC 'ston','e+$80
 FCC 'step','s+$80
 FCC 'leadin','g+$80
 FCB 't,'o+$80,'a+$80
 FCC 'doorway',0

 FCB 114,C.AN
 FCC 'ol','d+$80
 FCC 'vent',0

 FCB 115,'a+$80
 FCC 'grump','y+$80
 FCC 'ol','d+$80
 FCC 'man',0

 FCB 116,'a+$80
 FCC 'lectern',0

 FCB 117,'a+$80,C.LARG
 FCC 'circl','e+$80
 FCB 'o,'n+$80,C.THE
 FCC 'floor',0

 FCB 118
 FCC 'ston','e+$80
 FCC 'statues',0

 FCB 119,$FF,120,0

 FCB 120,'a+$80
 FCC 'bi','g+$80
 FCC 'manua','l+$80
 FCC 'pip','e+$80
 FCC 'organ',0

 FCB 121,'a+$80
 FCC 'ful','l+$80
 FCC 'lengt','h+$80
 FCC 'mirror',0

 FCB 122,'a+$80
 FCC 'close','t+$80
 FCC 'doorway',0

 FCB 123,'a+$80
 FCC 'bed',0

 FCB 124,'a+$80
 FCC 'fligh','t+$80,'o,'f+$80
 FCC 'stairs',0

 FCB 125,'a+$80
 FCC 'fireplace',0

 FCB 126,'a+$80,C.LARG
 FCC 'woode','n+$80
 FCC 'door',0

 FCB 127,$FF,126,0

*******************************
*
* ROOM DESCRIPTIONS TABLE
*
*******************************

DESCTB EQU *
*ROOM 1
 FCB C.IM,'i,'n+$80
 FCC 'rugge','d+$80
 FCC 'mountai','n+$80
 FCC 'country','.+$80
 FCC 'Sno','w+$80,C.IS
 FCC 'falling.',0
*ROOM 2
 FCB $FF,1,0
*ROOM 3
 FCB $FF,1,0
*ROOM 4
 FCB C.IM
 FCC 'outsid','e+$80,'a+$80
 FCC 'rustri','c+$80
 FCC 'mountai','n+$80
 FCC 'cabin','.+$80
 FCC 'Sno','w+$80,C.IS
 FCC 'falling.',0
*ROOM 5
 FCB C.IM,'i,'n+$80,C.THE
 FCC 'livin','g+$80
 FCC 'roo','m+$80
 FCB 'o,'f+$80,'a+$80
 FCC 'mountai','n+$80
 FCC 'cabin.',0
*ROOM 6
 FCB C.IM,C.INA
 FCC 'diml','y+$80,'l,'i,'t+$80
 FCC 'bedroom.',0
*ROOM 7
 FCB C.IM,C.INA,C.LARG
 FCC 'close','t+$80
 FCC 'use','d+$80,'f,'o,'r+$80
 FCC 'clothe','s+$80
 FCC 'storage.',0
*ROOM 8
 FCB C.IM,C.INA
 FCC 'lon','g+$80
 FCC 'narro','w+$80
 FCC 'corridor.',0
*ROOM 9
 FCB $FF,8,0
*ROOM 10
 FCB C.IM,'i,'n+$80,C.AN
 FCC 'impressiv','e+$80
 FCC 'roo','m+$80
 FCC 'wit','h+$80,'a+$80
 FCC 'cathedra','l+$80
 FCC 'ceiling.',0
*ROOM 11
 FCB C.IM,C.INA
 FCC 'ver','y+$80
 FCC 'strang','e+$80
 FCC 'room.',0
*ROOM 12
 FCB C.IM,'i,'n+$80,C.AN
 FCC 'arche','d+$80
 FCC 'passag','e+$80
 FCC 'unde','r+$80,C.THE
 FCC 'monastery.',0
*ROOM 13
 FCB C.IM,'i,'n+$80,C.AN
 FCC 'undergroun','d+$80
 FCC 'crypt.',0
*ROOM 14
 FCB $FF,8,0
*ROOM 15
 FCB C.IM,C.INA,C.SMAL
 FCC 'room.',0
*ROOM 16
 FCB $FF,8,0
*ROOM 17
 FCB C.IM,C.AT,C.THE
 FCC 'en','d+$80
 FCB 'o,'f+$80,'a+$80
 FCC 'lon','g+$80
 FCC 'narro','w+$80
 FCC 'corridor.',0
*ROOM 18
 FCB C.IM,C.INA
 FCC 'lof','t+$80,C.AT,C.THE
 FCC 'to','p+$80
 FCB 'o,'f+$80,C.THE
 FCC 'stairs.',0
*ROOM 19
 FCB $FF,8,0
*ROOM 20
 FCB C.IM,'i,'n+$80,C.AN
 FCC 'ol','d+$80
 FCC 'study.',0
*ROOM 21
 FCB $FF,8,0
*ROOM 22
 FCB $FF,17,0
*ROOM 23
 FCB C.IM,C.INA,C.SMAL
 FCC 'alcove.',0
*ROOM 24
 FCB C.IM,C.INA
 FCC 'strang','e+$80
 FCC 'place','.+$80,'M,'y+$80
 FCC 'bod','y+$80
 FCC 'feel','s+$80
 FCC 'paralyzed.',0

*******************************
*
* COMPRESSED PHRASE TABLE
*
*******************************

TXTTAB EQU *
 FCC 'th','e+$80,0
 FCC 'smal','l+$80,0
 FCC 'ar','e+$80,0
 FCC 'se','e+$80,0
 FCC 'can','','t+$80,0
 FCC 'don','','t+$80,0
 FCC 'larg','e+$80,0
 FCB 'I,'','m+$80,0
 FCB 'i,'n+$80,'a+$80,0
 FCB 'o,'n+$80,'a+$80,0
 FCB 'i,'s+$80,'a+$80,0
 FCC .It'.,'s+$80,0
 FCC 'Th','e+$80,0
 FCB 'i,'s+$80,0
 FCC 'an','d+$80,0
 FCB 'a,'n+$80,0
 FCB 'a,'t+$80,0

*******************************
*
* VERB ROUTINE JUMP VECTORS
*
*******************************

RTNTAB EQU *
 FDB VLOOK,VINVE,VGET,VPUT
 FDB VNORTH,VSOUTH,VEAST,VWEST
 FDB VUP,VDOWN,VGO,BADINP
 FDB VSAVE,VLOAD,VHELP,VSCORE
 FDB ENDGAM,BADINP,BADINP
 FDB BADINP,VPLAY,BADINP
 FDB VUNLOK,VBREAK,VBUILD
 FDB VPULL,VHEAR,VCUT,VLIGHT
 FDB VUNLIT,BADINP,BADINP
 FDB BADINP,VTASTE,BADINP
 FDB VDIG,VINVOK

*******************************
*
* NON ARRAY VARIABLES
*
*******************************

COMMA FCB ',+$80,0

*
* END OF FILE: ADVENT03/ASM
*
VBREAK,VBUILD
 FDB VPULL,VHEA